#include <stdio.h>
#include <stdlib.h>

void izracunaj(int poznanstva[][3],int a[], int prijatelji[], int neprijatelji[], int n, int m, int clan, int *max)
{
    if(clan==0)
    {
        int prov=provera(a,prijatelji,neprijatelji,n);
        if((*max)<prov)
        {
            (*max)=prov;
        }
        return;
    }
    izracunaj(poznanstva,a,prijatelji,neprijatelji,n,m,clan--,max);
    poznanstva[clan][2]=0;
    prijatelji[poznanstva[clan,0]]--;
    neprijatelji[poznanstva[clan,0]]++;
    prijatelji[poznanstva[clan,1]]--;
    neprijatelji[poznanstva[clan,1]]++;
    izracunaj(poznanstva,a,prijatelji,neprijatelji,n,m,clan--,max);
}

int provera(int a[], int prijatelji[], int neprijatelji[], int n)
{
    int suma=0;
    for(int i=0;i<n;i++)
    {
        suma+=a[i]*(prijatelji[i]-neprijatelji[i]);
    }
    return suma;
}

int main()
{
    int n,m;
    scanf("%d%d",&n,&m);
    int a[n],prijatelji[n],neprijatelji[n];
    for(int i=0;i<n;i++)
    {
        scanf("%d",&a[i]);
        prijatelji[i]=0;
        neprijatelji[i]=0;
    }
    int poznanstva[m][3];
    for(int i=0;i<m;i++)
    {
        scanf("%d%d",&poznanstva[i,0],&poznanstva[i,1]);
        poznanstva[i][2]=1;
        prijatejli[poznanstva[i,0]]++;
        prijatejli[poznanstva[i,1]]++;
    }
    int max=provera(a,prijatelji,neprijatelji,n);
    izracunaj(poznanstva,a,prijatelji,neprijatelji,n,m,m-1,&max);
    printf("%d",&max);
}